searchNodes=[{"doc":"This library allows you to download release artifacts from GitHub. By using this library you get the following functionality for your GitHub downloader client: Automatic SHA validation for downloaded artifacts (security measure to ensure that users download valid copies of artifacts) Automatic archive extraction for .zip and .tar.gz downloads Dynamic artifact downloading based on user's platform Support only specific versions of artifacts from the provided repo Sample usage If you want to make a downloader for the Litestream binary for example, you can define a downloader module like so: defmodule LiteStream.Downloader do use OctoFetch , latest_version : &quot;0.3.9&quot; , github_repo : &quot;benbjohnson/litestream&quot; , download_versions : %{ &quot;0.3.9&quot; =&gt; [ { :darwin , :amd64 , &quot;74599a34dc440c19544f533be2ef14cd4378ec1969b9b4fcfd24158946541869&quot; } , { :linux , :amd64 , &quot;806e1cca4a2a105a36f219a4c212a220569d50a8f13f45f38ebe49e6699ab99f&quot; } , { :linux , :arm64 , &quot;61acea9d960633f6df514972688c47fa26979fbdb5b4e81ebc42f4904394c5c5&quot; } ] , &quot;0.3.8&quot; =&gt; [ { :darwin , :amd64 , &quot;d359a4edd1cb98f59a1a7c787bbd0ed30c6cc3126b02deb05a0ca501ff94a46a&quot; } , { :linux , :amd64 , &quot;530723d95a51ee180e29b8eba9fee8ddafc80a01cab7965290fb6d6fc31381b3&quot; } , { :linux , :arm64 , &quot;1d6fb542c65b7b8bf91c8859d99f2f48b0b3251cc201341281f8f2c686dd81e2&quot; } ] } # You must implement this function to generate the names of the downloads based on the # user&#39;s current running environment @impl true def download_name ( version , :darwin , arch ) , do : &quot;litestream-v \#{ version } -darwin- \#{ arch } .zip&quot; def download_name ( version , :linux , arch ) , do : &quot;litestream-v \#{ version } -linux- \#{ arch } .tar.gz&quot; end You would then be able to download the release artifact by doing the following: Litestream.Downloader . download ( &quot;.&quot; ) If you are on an ARM based Mac, the above snippet won't work since Litestream does not currently build ARM artifacts. But you can always override what OctoFetch dynamically resolves by doing the following: Litestream.Downloader . download ( &quot;.&quot; , override_architecture : :amd64 ) Be sure to look at the OctoFetch.download/3 docs for supported options and OctoFetch.Downloader to see what behaviour callbacks you can override.","ref":"OctoFetch.html","title":"OctoFetch","type":"module"},{"doc":"Download the GitHub release artifact and write it to the specified location. The supported opts arguments are: override_version : By default, the latest version (as specified by the downloader module) will be downloaded. But you can also specify any additional versions that are also supported by the :download_versions map. override_operating_system : By default, the operating system is dynamically deteremined based on the what the BEAM reports. If you would like to override those results, you can pass :windows , :darwin , or :linux . override_architecture : By default, the architecture is dynamically deteremined based on the what the BEAM reports. If you would like to override those results, you can pass :amd64 or :arm64 .","ref":"OctoFetch.html#download/3","title":"OctoFetch.download/3","type":"function"},{"doc":"This module defines the callbacks that a GitHub downloader needs to implement in order to fetch artifacts from GitHub. base_url/2 and default_version/0 are automatically implemented for you when you use the OctoFetch module, but you always have the option to override their default implementations.","ref":"OctoFetch.Downloader.html","title":"OctoFetch.Downloader","type":"behaviour"},{"doc":"This callback generates the base URL for the artifact based on the provided GitHub repo and the requested version. The default implementation from OctoFetch is: def base_url ( github_repo , version ) do &quot;https://github.com/ \#{ github_repo } /releases/download/v \#{ version } /&quot; end","ref":"OctoFetch.Downloader.html#c:base_url/2","title":"OctoFetch.Downloader.base_url/2","type":"callback"},{"doc":"This callback returns the default version that sould be downloaded if the user does not override the version. It will default to the value of :latest_version as provided to the OctoFetch __using__/1 macro.","ref":"OctoFetch.Downloader.html#c:default_version/0","title":"OctoFetch.Downloader.default_version/0","type":"callback"},{"doc":"This callback acts as a pass through to the OctoFetch module for the downloader implementation. See OctoFetch.download/3 for supported opts .","ref":"OctoFetch.Downloader.html#c:download/2","title":"OctoFetch.Downloader.download/2","type":"callback"},{"doc":"This function must be implemented by your downloader module and is used to dynamically generate the name of the download artifact based on the user's running environment. For example, for Litestream you would do something like so to ensure that users download the proper artifact: def download_name ( version , :darwin , arch ) , do : &quot;litestream-v \#{ version } -darwin- \#{ arch } .zip&quot; def download_name ( version , :linux , arch ) , do : &quot;litestream-v \#{ version } -linux- \#{ arch } .tar.gz&quot;","ref":"OctoFetch.Downloader.html#c:download_name/3","title":"OctoFetch.Downloader.download_name/3","type":"callback"},{"doc":"This callback is invoked whenever a file is written to the filesystem as a result from the download. This callback may be invoked several times if the download was an archive file and contained multiple files.","ref":"OctoFetch.Downloader.html#c:post_write_hook/1","title":"OctoFetch.Downloader.post_write_hook/1","type":"callback"},{"doc":"This callback is invoked prior to a file being downloaded. This gives you the opportunity to skip the download if you so chose by returning :skip . Otherwise, return :cont to continue with the download.","ref":"OctoFetch.Downloader.html#c:pre_download_hook/2","title":"OctoFetch.Downloader.pre_download_hook/2","type":"callback"},{"doc":"","ref":"OctoFetch.Downloader.html#t:arch/0","title":"OctoFetch.Downloader.arch/0","type":"type"},{"doc":"","ref":"OctoFetch.Downloader.html#t:download_result/0","title":"OctoFetch.Downloader.download_result/0","type":"type"},{"doc":"","ref":"OctoFetch.Downloader.html#t:os/0","title":"OctoFetch.Downloader.os/0","type":"type"},{"doc":"This module contains testing utilities to validate downloader modules and their implementations.","ref":"OctoFetch.Test.html","title":"OctoFetch.Test","type":"module"},{"doc":"Go through all of the supported downloads and validate that they work.","ref":"OctoFetch.Test.html#test_all_supported_downloads/1","title":"OctoFetch.Test.test_all_supported_downloads/1","type":"function"},{"doc":"Test that the specified version can be downloaded","ref":"OctoFetch.Test.html#test_version_for_current_platform/2","title":"OctoFetch.Test.test_version_for_current_platform/2","type":"function"},{"doc":"Download, verify, and extract GitHub release artifacts effortlessly right from Elixir Contents Installation Supporting OctoFetch Setting Up OctoFetch Attribution","ref":"readme.html","title":"README","type":"extras"},{"doc":"Available in Hex , the package can be installed by adding octo_fetch to your list of dependencies in mix.exs : def deps do [ { :octo_fetch , &quot;~&gt; 0.3.0&quot; } ] end Documentation can be found at https://hexdocs.pm/octo_fetch .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"If you rely on this library, it would much appreciated if you can give back to the project in order to help ensure its continued development. Gold Sponsors Silver Sponsors Bronze Sponsors","ref":"readme.html#supporting-octofetch","title":"README - Supporting OctoFetch","type":"extras"},{"doc":"If you want to create a downloader utility for a particular GitHub repository, you can use this library to take care of all of the boilerplate, validation, and archive extraction. For example, if you want to create a downloader for Litestream, you can do the following: defmodule LiteStream.Downloader do use OctoFetch , latest_version : &quot;0.3.9&quot; , github_repo : &quot;benbjohnson/litestream&quot; , download_versions : %{ &quot;0.3.9&quot; =&gt; [ { :darwin , :amd64 , &quot;74599a34dc440c19544f533be2ef14cd4378ec1969b9b4fcfd24158946541869&quot; } , { :linux , :amd64 , &quot;806e1cca4a2a105a36f219a4c212a220569d50a8f13f45f38ebe49e6699ab99f&quot; } , { :linux , :arm64 , &quot;61acea9d960633f6df514972688c47fa26979fbdb5b4e81ebc42f4904394c5c5&quot; } ] , &quot;0.3.8&quot; =&gt; [ { :darwin , :amd64 , &quot;d359a4edd1cb98f59a1a7c787bbd0ed30c6cc3126b02deb05a0ca501ff94a46a&quot; } , { :linux , :amd64 , &quot;530723d95a51ee180e29b8eba9fee8ddafc80a01cab7965290fb6d6fc31381b3&quot; } , { :linux , :arm64 , &quot;1d6fb542c65b7b8bf91c8859d99f2f48b0b3251cc201341281f8f2c686dd81e2&quot; } ] } # You must implement this function to generate the names of the downloads based on the # user&#39;s current running environment @impl true def download_name ( version , :darwin , arch ) , do : &quot;litestream-v \\# {version}-darwin- \\# {arch}.zip&quot; def download_name ( version , :linux , arch ) , do : &quot;litestream-v \\# {version}-linux- \\# {arch}.tar.gz&quot; end You would then be able to download the release artifact by doing the following: iex ( 1 ) &gt; Litestream.Downloader . download ( &quot;.&quot; ) { :ok , [ &quot;./litestream&quot; ] , [ ] }","ref":"readme.html#setting-up-octofetch","title":"README - Setting Up OctoFetch","type":"extras"},{"doc":"It wouldn't be right to not include somewhere in this project a &quot;thank you&quot; to the various projects and people that helped make this possible: The logo for the project is an edited version of an SVG image from the unDraw project The work done in Phoenix Tailwind served as a baseline for how to structure this library.","ref":"readme.html#attribution","title":"README - Attribution","type":"extras"}]